
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#asm
   .equ __lcd_port=0x12 ;PORTD
#endasm

#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);

void lcd_write_byte(unsigned char addr, unsigned char data);

unsigned char lcd_read_byte(unsigned char addr);

void lcd_gotoxy(unsigned char x, unsigned char y);

void lcd_clear(void);
void lcd_putchar(char c);

void lcd_puts(char *str);

void lcd_putsf(char flash *str);

unsigned char lcd_init(unsigned char lcd_columns);

void lcd_control (unsigned char control);

#pragma used-
#pragma library lcd.lib

unsigned char lcd_buffer[16];               
unsigned char i=0;                          
unsigned char j=0;
unsigned char ENC_COUNT=0;                  

unsigned int EncData=0;                       
unsigned int F0=0;
float temp;
float div1;

void InitEncoder(void)
{
DDRC.5  = 0;      
DDRC.4  = 0;
DDRC.3  = 0;      
PORTC.5 = 1;      
PORTC.4 = 1;      
PORTC.3 = 1;      
}

void Encquest(void)
{         

if (PINC.3 == 0)                 
{
delay_ms(500);               
if (PINC.3 == 0) 
{
lcd_clear();
lcd_gotoxy(0,0); 
#pragma rl+ 
lcd_putsf(" ");     
lcd_puts(lcd_buffer);
lcd_gotoxy(0,1);
lcd_putsf("  ");
#pragma rl- 
delay_ms(800);
lcd_clear();  
ENC_COUNT++;
}
if (ENC_COUNT>3) {ENC_COUNT = 0;}
}

switch (ENC_COUNT) 
{                                                                  
case 0:{if ((PINC.4==0)&(PINC.5==1)&(EncData<30000                     ))              
{
delay_ms(50);
EncData += 1;
};                                                    
if ((PINC.4==1)&(PINC.5==0)&(EncData>0                     ))             
{
delay_ms(50);
EncData -= 1;
};
break;
} 
case 1:{
if ((PINC.4==0)&(PINC.5==1)&(EncData<=(30000                     -10)))
{
delay_ms(50);
EncData += 10;
};
if ((PINC.4==1)&(PINC.5==0)&(EncData>=(0                     +10))) 
{
delay_ms(50);
EncData -= 10;
};
break; 
}
case 2:{
if ((PINC.4==0)&(PINC.5==1)&(EncData<=(30000                     -100)))
{
delay_ms(50);
EncData += 100;
};
if ((PINC.4==1)&(PINC.5==0)&(EncData>=(0                     +100))) 
{
delay_ms(50);
EncData -= 100;
};
break; 
}
case 3:{
if ((PINC.4==0)&(PINC.5==1)&(EncData<=(30000                     -1000)))
{
delay_ms(50);
EncData += 1000;
};
if ((PINC.4==1)&(PINC.5==0)&(EncData>=(0                     +1000))) 
{
delay_ms(50);
EncData -= 1000;
};
break; 
}      

}        

}      

void LCD_LOAD (void)
{  
while (i<17)
{
delay_ms (100);
i++;     
if (i>8) 
{
delay_ms (10);                 
j++;
lcd_gotoxy(j-1,1);
}
else {lcd_gotoxy(i-1,0);}
lcd_putchar(0xFF);
}
}

interrupt [10] void timer0_ovf_isr(void)
{

Encquest(); 

}

void main(void)
{

PORTB=0x00;
DDRB=0x00;

PORTC=0xFF;
DDRC=0x00;

PORTD=0x00;
DDRD=0x00;

TCCR0=0x03;
TCNT0=0x00;

TCCR1A=0x40;
TCCR1B=0x0B;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

MCUCR=0x00;

TIMSK=0x01;

ACSR=0x80;
SFIOR=0x00;

lcd_init(16);

InitEncoder();

#asm("sei")

LCD_LOAD();
lcd_clear();                                                
#pragma rl+                         
lcd_putsf("");                                      
lcd_puts(lcd_buffer);                                       
lcd_gotoxy(0,1);                                            
lcd_putsf(" .");
#pragma rl-
delay_ms(2000);
lcd_clear();

while (1)
{

if (EncData>0)
{
DDRB=0x02;                          
F0 = EncData;
div1 = (float)(2*64.000                 *F0);                
temp = (float)((8000000.000                   /div1)-1);        
OCR1A = temp;
}
if (F0!=EncData)
{
F0 = EncData;
}        
if ((F0>0)&(F0<1000)) 
{
lcd_gotoxy(0,0);                                      
sprintf(lcd_buffer, "%8u", F0);                     
lcd_puts(lcd_buffer);                                 
lcd_gotoxy(0,1);                                      
#pragma rl+ 
lcd_putsf("      ");
lcd_puts(lcd_buffer);
#pragma rl-  
}

else 
{
if (F0>0)
{
lcd_gotoxy(0,1); 
#pragma rl+ 
lcd_putsf("     ");                                    
lcd_puts(lcd_buffer);
#pragma rl- 
}
if ((F0>0)&(F0%1000)<10)
{
lcd_gotoxy(0,0); 
sprintf(lcd_buffer,"%4u.00%u", F0/1000, F0%1000);             
lcd_puts(lcd_buffer);                                  
}

if ((F0>0)&((F0%1000)>=10)&((F0%1000)<100))
{
lcd_gotoxy(0,0); 
sprintf(lcd_buffer,"%4u.0%u", F0/1000, F0%1000);             
lcd_puts(lcd_buffer);                                  
}

if ((F0>0)&(F0%1000)>=100)
{
lcd_gotoxy(0,0); 
sprintf(lcd_buffer,"%4u.%u", F0/1000, F0%1000);             
lcd_puts(lcd_buffer);                                  
}

}  

};
}
